Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_send.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_send.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_send.cpp	(revision 1134)
@@ -0,0 +1,318 @@
+/*!
+   \file ep_send.hpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI send functions: MPI_Send, MPI_Ssend, MPI_Isend, MPI_Issend
+ */
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+
+namespace ep_lib {
+
+
+  int MPI_Send(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    if(!comm.is_ep)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Send(buf, count, static_cast< ::MPI_Datatype>(datatype), dest, tag, mpi_comm);
+      return 0;
+    }
+
+    MPI_Request request;
+    MPI_Status status;
+    MPI_Isend(buf, count, datatype, dest, tag, comm, &request);
+    MPI_Wait(&request, &status);
+
+    //check_sum_send(buf, count, datatype, dest, tag, comm);
+
+    return 0;
+  }
+
+
+  int MPI_Ssend(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    if(!comm.is_ep)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Ssend(buf, count, static_cast< ::MPI_Datatype>(datatype), dest, tag, mpi_comm);
+      return 0;
+    }
+
+    MPI_Request request;
+    MPI_Status status;
+    MPI_Issend(buf, count, datatype, dest, tag, comm, &request);
+    MPI_Wait(&request, &status);
+    //check_sum_send(buf, count, datatype, dest, tag, comm);
+    return 0;
+  }
+
+
+
+  int MPI_Isend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Isend with EP\n");
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+    
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Request mpi_request;
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Isend(buf, count, static_cast< ::MPI_Datatype> (datatype), dest, tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+
+      request->ep_src = src_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+      request->type = 1;
+      request->comm = comm;
+
+      return 0;
+    }
+
+    if(comm.is_intercomm) return MPI_Isend_intercomm(buf, count, datatype, dest, tag, comm, request);
+
+    // EP intracomm
+
+    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
+
+    int ep_src_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm.ep_comm_ptr->comm_list->rank_map->at(dest).first;
+    int mpi_tag 		= tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest 	= comm.ep_comm_ptr->comm_list->rank_map->at(dest).second;
+
+    request->ep_src  = src_rank;
+    request->ep_tag  = tag;
+    request->ep_datatype = datatype;
+
+    ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+    ::MPI_Request mpi_request;
+
+    ::MPI_Isend(buf, count, static_cast< ::MPI_Datatype>(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+    request->mpi_request = mpi_request;
+    request->type = 1; 		// used in wait
+    request->comm = comm;
+
+    Message_Check(comm);
+
+    return 0;
+  }
+
+
+
+
+  int MPI_Issend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Issend with EP\n");
+
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+    
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Request mpi_request;
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Issend(buf, count, static_cast< ::MPI_Datatype> (datatype), dest, tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+      request->ep_src = src_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+      request->type = 1;
+      request->comm = comm;
+
+      return 0;
+    }
+
+    if(comm.is_intercomm) return MPI_Issend_intercomm(buf, count, datatype, dest, tag, comm, request);
+
+    // EP intracomm
+
+    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
+
+    int ep_src_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm.ep_comm_ptr->comm_list->rank_map->at(dest).first;
+    int mpi_tag 		= tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest 	= comm.ep_comm_ptr->comm_list->rank_map->at(dest).second;
+    
+    request->ep_src = src_rank;
+    request->ep_tag = tag;
+    request->ep_datatype = datatype;
+
+    ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+    ::MPI_Request mpi_request;
+
+    ::MPI_Issend(buf, count, static_cast< ::MPI_Datatype>(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+    request->mpi_request = mpi_request;
+    request->type = 1; 		// used in wait
+    request->comm = comm;
+    
+
+    //Message_Check(comm);
+
+    return 0;
+  }
+
+
+
+  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("MPI_Isend with intercomm\n");
+
+    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
+
+    int dest_remote_ep_rank    = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).first;
+    int dest_remote_comm_label = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).second;
+
+    int src_ep_rank    = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
+    int src_comm_label;
+
+    for(int i=0; i<comm.ep_comm_ptr->intercomm->local_rank_map->size(); i++)
+    {
+      if(comm.ep_comm_ptr->intercomm->local_rank_map->at(i).first == src_ep_rank)
+      {
+        src_comm_label = comm.ep_comm_ptr->intercomm->local_rank_map->at(i).second;
+        break;
+      }
+    }
+
+    Message_Check(comm);
+
+
+    if(dest_remote_comm_label == src_comm_label)       // mpi_dest differs
+    {
+      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
+      int ep_src_loc = comm.rank_map->at(inter_src).first;
+      int ep_dest_loc = comm.rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm.rank_map->at(dest_remote_ep_rank).second;
+      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Request mpi_request;
+  
+      ::MPI_Isend(buf, count, static_cast< ::MPI_Datatype >(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+      request->type = 1; 		// used in wait
+      request->comm = comm;
+
+      request->ep_src = src_ep_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+    }
+
+    else   // dest_remote_comm_label != src_comm_label
+    { 
+      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
+      int ep_src_loc = comm.rank_map->at(inter_src).first;
+      int ep_dest_loc = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
+      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm >(comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+      ::MPI_Request mpi_request;
+
+      ::MPI_Isend(buf, count, static_cast< ::MPI_Datatype >(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+      request->type = 1; 		// used in wait
+      request->comm = comm;
+   
+      request->ep_src = src_ep_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+    }
+
+    return 0;
+
+  }
+
+
+  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("MPI_Issend with intercomm\n");
+
+    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
+
+    int dest_remote_ep_rank    = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).first;
+    int dest_remote_comm_label = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).second;
+
+    int src_ep_rank    = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
+    int src_comm_label;
+
+    for(int i=0; i<comm.ep_comm_ptr->intercomm->local_rank_map->size(); i++)
+    {
+      if(comm.ep_comm_ptr->intercomm->local_rank_map->at(i).first == src_ep_rank)
+      {
+        src_comm_label = comm.ep_comm_ptr->intercomm->local_rank_map->at(i).second;
+        break;
+      }
+    }
+
+    Message_Check(comm);
+
+
+    if(dest_remote_comm_label == src_comm_label)       // dest rank (loc, mpi) differs
+    {
+      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
+      int ep_src_loc = comm.rank_map->at(inter_src).first;
+      int ep_dest_loc = comm.rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm.rank_map->at(dest_remote_ep_rank).second;
+      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Request mpi_request;
+  
+      ::MPI_Issend(buf, count, static_cast< ::MPI_Datatype >(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+      request->type = 1; 		// used in wait
+      request->comm = comm;
+
+      request->ep_src = src_ep_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+    }
+
+    else   // dest_remote_comm_label != src_comm_label
+    { 
+      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
+      int ep_src_loc = comm.rank_map->at(inter_src).first;
+      int ep_dest_loc = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
+      int mpi_dest    = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
+      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm >(comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+      ::MPI_Request mpi_request;
+
+      ::MPI_Issend(buf, count, static_cast< ::MPI_Datatype >(datatype), mpi_dest, mpi_tag, mpi_comm, &mpi_request);
+
+      request->mpi_request = mpi_request;
+      request->type = 1; 		// used in wait
+      request->comm = comm;
+   
+      request->ep_src = src_ep_rank;
+      request->ep_tag = tag;
+      request->ep_datatype = datatype;
+    }
+
+    return 0;
+
+  }
+}
+
+
+
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_size.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_size.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_size.cpp	(revision 1134)
@@ -0,0 +1,80 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+
+
+
+  int MPI_Comm_size(MPI_Comm comm, int* size)
+  {
+    
+    if(comm.is_ep)
+    {
+      if(!comm.is_intercomm)
+      {
+        *size = comm.ep_comm_ptr->size_rank_info[0].second;
+
+        return 0;
+      }
+      else
+      {
+        *size = comm.ep_comm_ptr->intercomm->size_rank_info[0].second;
+
+        return 0;
+      }
+
+    }
+
+    Debug("Calling EP_Comm_size\n");
+
+    if(comm.mpi_comm != MPI_COMM_NULL_STD)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm); 
+      int mpi_size;
+
+      ::MPI_Comm_size(mpi_comm, &mpi_size);
+      printf("============ ep comm size called for non ep comm, %d\n", mpi_size);
+      *size = mpi_size;
+      return 0;
+    }
+
+    else
+    {
+      *size = MPI_UNDEFINED;
+      printf("============ ep comm size called for non ep comm not defined\n");
+      return 0;
+    }
+  }
+
+  int MPI_Comm_remote_size(MPI_Comm comm, int *size)
+  {
+    if(!comm.is_ep)
+    {
+      if(comm.mpi_comm != MPI_COMM_NULL_STD)
+      {
+        ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm); 
+        ::MPI_Comm_remote_size(mpi_comm, size);
+        return 0;
+      }
+
+      else
+      {
+        *size = MPI_UNDEFINED;
+        return 0;
+      }
+    }
+    
+    if(comm.is_intercomm)
+    {
+      *size = comm.ep_comm_ptr->intercomm->remote_rank_map->size();
+      return 0;
+    }
+    *size = MPI_UNDEFINED;
+    return 0; 
+  }
+}
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_split.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_split.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_split.cpp	(revision 1134)
@@ -0,0 +1,179 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+namespace ep_lib
+{
+
+  void vec_simplify(std::vector<int> *inout_vector)
+  {
+    std::vector<int> out_vec;
+    int found=false;
+    for(std::vector<int>::iterator it_in = inout_vector->begin() ; it_in != inout_vector->end(); ++it_in)
+    {
+      for(std::vector<int>::iterator it = out_vec.begin() ; it != out_vec.end(); ++it)
+      {
+        if(*it_in == *it)
+        {
+          found=true;
+          break;
+        }
+        else found=false;
+      }
+      if(found == false)
+      {
+        out_vec.push_back(*it_in);
+      }
+    }
+    inout_vector->swap(out_vec);
+  }
+
+
+
+  int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm)
+  {
+    int ep_rank, ep_rank_loc, mpi_rank;
+    int ep_size, num_ep, mpi_size;
+
+    ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
+    ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
+    num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+
+
+
+
+    int num_color = 0;
+
+    int color_index;
+
+    vector<int> matched_number;
+    vector<int> matched_number_loc;
+
+
+    vector<int> all_color(ep_size);
+    vector<int> all_color_loc(num_ep);
+
+    MPI_Gather_local(&color, 1, MPI_INT, all_color_loc.data(), comm);
+    MPI_Bcast_local(all_color_loc.data(), num_ep, MPI_INT, comm);
+
+
+    MPI_Allgather(&color, 1, MPI_INT, all_color.data(), 1, MPI_INT, comm);
+
+    list<int> color_list(all_color.begin(), all_color.end());
+    list<int> color_list_loc(all_color_loc.begin(), all_color_loc.end());
+
+    vec_simplify(&all_color);
+
+    matched_number.resize(all_color.size(), 0);
+    matched_number_loc.resize(all_color.size(), 0);
+
+
+    while(!color_list.empty())
+    {
+      int target_color = color_list.front();
+      for(list<int>::iterator it = color_list.begin(); it != color_list.end(); ++it)
+      {
+        if(*it == target_color)
+        {
+          matched_number[num_color]++;
+        }
+      }
+      for(list<int>::iterator it = color_list_loc.begin(); it != color_list_loc.end(); ++it)
+      {
+        if(*it == target_color)
+        {
+          matched_number_loc[num_color]++;
+        }
+      }
+      color_list.remove(target_color);
+      color_list_loc.remove(target_color);
+      num_color++;
+    }
+
+
+    vector<int> colored_key_loc[num_color];
+    vector<int> key_loc(num_ep);
+
+    MPI_Gather_local(&key, 1, MPI_INT, key_loc.data(), comm);
+    MPI_Bcast_local(key_loc.data(), num_ep, MPI_INT, comm);
+
+    for(int i=0; i<num_ep; i++)
+    {
+      for(int j = 0; j<num_color; j++)
+      {
+        if(all_color_loc[i] == all_color[j])
+        {
+          colored_key_loc[j].push_back(key_loc[i]);
+        }
+      }
+    }
+
+    int new_ep_rank_loc;
+
+    for(int i=0; i<num_color; i++)
+    {
+      if(colored_key_loc[i].size()>1)
+      {
+        std::sort(colored_key_loc[i].begin(), colored_key_loc[i].end());
+      }
+      if(color == all_color[i])
+      {
+        //color_index = i;
+        for(int j=0; j<colored_key_loc[i].size(); j++)
+        {
+          if(key == colored_key_loc[i][j])
+          {
+            new_ep_rank_loc = j;
+            break;
+          }
+        }
+      }
+    }
+
+    ::MPI_Comm split_mpi_comm[num_color];
+
+    for(int j=0; j<num_color; j++)
+    {
+      if(ep_rank_loc == 0)
+      {
+        int master_color = 1;
+        if(matched_number_loc[j] == 0) master_color = MPI_UNDEFINED;
+
+        ::MPI_Comm_split(static_cast< ::MPI_Comm>(comm.mpi_comm), master_color, mpi_rank, &split_mpi_comm[j]);
+        
+        comm.ep_comm_ptr->comm_list->mpi_bridge = split_mpi_comm[j];
+      }
+      MPI_Barrier_local(comm);
+      int num_new_ep = 0;
+
+      if(new_ep_rank_loc == 0 && color == all_color[j])
+      {
+        num_new_ep = matched_number_loc[j];
+        MPI_Info info;
+        MPI_Comm *ep_comm;
+
+        MPI_Comm_create_endpoints(comm.ep_comm_ptr->comm_list->mpi_bridge, num_new_ep, info, ep_comm);
+
+
+        comm.ep_comm_ptr->comm_list->mem_bridge = ep_comm;
+      }
+      MPI_Barrier_local(comm);
+      if(color == all_color[j])
+      {
+        *newcomm = comm.ep_comm_ptr->comm_list->mem_bridge[new_ep_rank_loc];
+ //       newcomm = &(comm.ep_comm_ptr->comm_list->mem_bridge[new_ep_rank_loc]);
+        (*newcomm).ep_comm_ptr->comm_label = color;
+      }
+    }
+
+
+
+    return 0;
+  }
+
+}
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_tag.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_tag.hpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_tag.hpp	(revision 1134)
@@ -0,0 +1,25 @@
+#ifndef EP_TAG_HPP_INCLUDED
+#define EP_TAG_HPP_INCLUDED
+
+
+
+namespace ep_lib
+{
+  int print_comm_info(MPI_Comm comm);
+
+
+
+//  int MPI_Imrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Request *request);
+//  int MPI_Mrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message);
+
+
+//  int MPI_Testall(int count, MPI_Request *array_of_requests, int *flag, MPI_Status *array_of_statuses);
+//  int MPI_Testany(int count, MPI_Request *array_of_requests, int *index, int *flag, MPI_Status *status);
+//  int MPI_Testsome(int incount, MPI_Request *array_of_requests, int *outcount, int *array_of_indices, MPI_Status *array_of_statuses);
+
+
+//  int MPI_Waitany(int count, MPI_Request *array_of_requests,  int *index, MPI_Status *array_of_statuses);
+//  int MPI_Waitsome(int incount, MPI_Request *array_of_requests, int *outcount, int *array_of_indices, MPI_Status *array_of_statuses);
+}
+
+#endif // EP_TAG_HPP_INCLUDED
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_test.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_test.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_test.cpp	(revision 1134)
@@ -0,0 +1,97 @@
+/*!
+   \file ep_test.cpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI test function: MPI_Test, MPI_Testsome, MPI_Testany, MPI_Testall
+ */
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+
+namespace ep_lib {
+
+	int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status)
+	{
+		Debug("MPI_Test with EP");
+
+    *flag = false;
+
+    if(request->type == 1)      // isend
+    {
+      ::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
+      ::MPI_Status mpi_status;
+      ::MPI_Test(&mpi_request, flag, &mpi_status);
+      
+      if(*flag) 
+      {
+        status->mpi_status = new ::MPI_Status(mpi_status);
+        status->ep_src = request->ep_src;
+        status->ep_tag = request->ep_tag;
+        status->ep_datatype = request->ep_datatype;
+      }
+
+      return 0;
+    }
+
+    if(request->type == 2)   // irecv message not probed
+    {
+      Message_Check(request->comm);
+      #pragma omp flush
+      MPI_Message message;
+      MPI_Improbe(request->ep_src, request->ep_tag, request->comm, flag, &message, status);
+      if(*flag)
+      {
+        int count;
+        MPI_Get_count(status, request->ep_datatype, &count);
+        MPI_Imrecv(request->buf, count, request->ep_datatype, &message, request);
+        MPI_Test(request, flag, status);
+      }
+      return 0;
+    }
+
+    if(request->type == 3)  // imrecv
+    {
+      ::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
+      ::MPI_Status mpi_status;
+      ::MPI_Test(&mpi_request, flag, &mpi_status);
+      if(*flag)
+      {
+        status->mpi_status = new ::MPI_Status(mpi_status);
+        status->ep_src = request->ep_src;
+        status->ep_tag = request->ep_tag;
+        status->ep_datatype = request->ep_datatype;
+        //int count;
+        //MPI_Get_count(status, request->ep_datatype, &count);
+        //check_sum_recv(request->buf, count, request->ep_datatype, request->ep_src, request->ep_tag, request->comm, 2);
+      }
+
+      status->ep_src = request->ep_src;
+      status->ep_tag = request->ep_tag;
+      status->ep_datatype = request->ep_datatype;
+
+      
+
+      return 0;
+    }
+		
+	}
+
+
+	int MPI_Testall(int count, MPI_Request *array_of_requests, int *flag, MPI_Status *array_of_statuses)
+	{
+	  Debug("MPI_Testall with EP");
+    *flag = true;
+    int i=0;
+    while(*flag && i<count )
+    {
+      MPI_Test(&array_of_requests[i], flag, &array_of_statuses[i]);
+      i++;
+    }
+	}
+
+
+}
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_type.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_type.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_type.cpp	(revision 1134)
@@ -0,0 +1,56 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+
+
+using namespace std;
+
+::MPI_Comm MPI_COMM_WORLD_STD = MPI_COMM_WORLD;
+#undef MPI_COMM_WORLD
+
+
+::MPI_Comm MPI_COMM_NULL_STD = MPI_COMM_NULL;
+#undef MPI_COMM_NULL
+
+
+::MPI_Request MPI_REQUEST_NULL_STD = MPI_REQUEST_NULL;
+#undef MPI_REQUEST_NULL
+
+::MPI_Info MPI_INFO_NULL_STD = MPI_INFO_NULL;
+#undef MPI_INFO_NULL
+
+::MPI_Datatype MPI_INT_STD = MPI_INT;
+::MPI_Datatype MPI_FLOAT_STD = MPI_FLOAT;
+::MPI_Datatype MPI_DOUBLE_STD = MPI_DOUBLE;
+::MPI_Datatype MPI_LONG_STD = MPI_LONG;
+::MPI_Datatype MPI_CHAR_STD = MPI_CHAR;
+::MPI_Datatype MPI_UNSIGNED_LONG_STD = MPI_UNSIGNED_LONG;
+::MPI_Datatype MPI_UNSIGNED_CHAR_STD = MPI_UNSIGNED_CHAR;
+
+#undef MPI_INT
+#undef MPI_FLOAT
+#undef MPI_DOUBLE
+#undef MPI_LONG
+#undef MPI_CHAR
+#undef MPI_UNSIGNED_LONG
+#undef MPI_UNSIGNED_CHAR
+
+
+::MPI_Op MPI_SUM_STD = MPI_SUM;
+::MPI_Op MPI_MAX_STD = MPI_MAX;
+::MPI_Op MPI_MIN_STD = MPI_MIN;
+
+#undef MPI_SUM
+#undef MPI_MAX
+#undef MPI_MIN
+
+
+
+
+
+
+
+
+
+
+
+
